<script setup lang="ts">
  const { isGuide } = useUser();
  const { subtotal, shippingTotal, totalPrice, isNetPrice, netPrice, isEmpty, calculatedTaxes } =
    useCart();
  const { getFormattedPrice } = usePrice();

  const showCartDetail = ref(false);

  const checkout = () => {
    window.open('/checkout', '_blank', 'noopener,noreferrer');
  };
</script>
<template>
  <div class="shadow-5 border-information-disabled bg-background-raised border-t p-5">
    <slot name="cart-detail">
      <div class="flex flex-col">
        <div
          class="text-(sm primary) cursor-pointer font-medium"
          @click="showCartDetail = !showCartDetail"
        >
          {{ showCartDetail ? $t('cart.hideDetails') : $t('cart.showDetails') }}
        </div>
        <ul
          v-if="showCartDetail"
          class="border-(t information-disabled) mt-3 flex flex-col gap-1 pt-3"
        >
          <li class="text-(sm information) flex justify-between leading-6">
            <span>{{ isNetPrice ? $t('cart.subTotal') : $t('cart.subIncludeTax') }}</span>
            <span class="font-medium">{{ getFormattedPrice(subtotal, true) }}</span>
          </li>
          <li class="text-(sm information) flex justify-between leading-6">
            <span>{{ $t('cart.estimatedShipping') }}</span>
            <span class="font-medium">{{ getFormattedPrice(shippingTotal, true) }}</span>
          </li>
          <template v-if="isNetPrice">
            <li class="text-(sm information) flex justify-between pt-2 leading-6">
              <span>{{ $t('checkout.totalNet') }}</span>
              <span class="font-medium">{{ getFormattedPrice(netPrice, false) }}</span>
            </li>
            <li
              v-for="(calculatedTax, index) of calculatedTaxes"
              :key="`tax-${index}`"
              class="text-(sm information) flex justify-between leading-6"
            >
              <span>
                {{
                  $t('checkout.summaryLabelTaxes', {
                    taxRate: calculatedTax.taxRate,
                  })
                }}
              </span>
              <span class="font-medium">{{ getFormattedPrice(calculatedTax.tax, false) }}</span>
            </li>
          </template>
        </ul>
      </div>
    </slot>

    <slot name="cart-total-price">
      <div :class="[{ 'border-(t information-disabled) mt-3 pt-3': showCartDetail }]">
        <div class="flex justify-between pt-1 text-lg font-semibold">
          <span>{{ $t('cart.estimatedTotal') }}</span>
          <span>{{ getFormattedPrice(totalPrice, !isNetPrice) }}</span>
        </div>
        <ul v-if="showCartDetail && !isNetPrice" class="flex flex-col gap-1">
          <li class="text-(sm information) flex justify-between leading-6">
            <span>{{ $t('checkout.totalNet') }}</span>
            <span class="font-medium">{{ getFormattedPrice(netPrice, false) }}</span>
          </li>
          <li
            v-for="(calculatedTax, index) of calculatedTaxes"
            :key="`tax-${index}`"
            class="text-(sm information) flex justify-between leading-6"
          >
            <span>
              {{
                $t('checkout.summaryLabelTaxes', {
                  taxRate: calculatedTax.taxRate,
                })
              }}
            </span>
            <span class="font-medium">{{ getFormattedPrice(calculatedTax.tax, false) }}</span>
          </li>
        </ul>
        <span class="text-(sm information) flex justify-between leading-6">
          {{ $t('star') }}
          {{ !isNetPrice ? $t('product.includeTaxInfo') : $t('product.excludeTaxInfo') }}
        </span>
      </div>
    </slot>

    <slot name="cart-checkout">
      <SwButton
        v-if="!isGuide"
        size="large"
        variant="primary"
        class="mt-3 w-full"
        :disabled="isEmpty"
        @click="checkout"
      >
        {{ $t('cart.checkout') }}
      </SwButton>
    </slot>
  </div>
</template>
